Subject: Re: [PATCH -rt DO NOT APPLY] Fix for tg3 networking lockup

From: Theodore Tso <[email-masked]>
Date: Thu, 3 Aug 2006 12:32:05 -0400

On Thu, Aug 03, 2006 at 08:00:35PM +1000, Herbert Xu wrote:
> Theodore Tso <[email-masked]> wrote:
> > 
> > I'm sending this on mostly because it was a bit of a pain to track down,
> > and hopefully it will save time if anyone else hits this while playing
> > with the -rt kernel.  It is NOT the right way to fix things, so please
> > don't even think of applying this patch (unless you need it, in your own
> > local tree :-).
> > 
> > One of these days when we have time to breath we'll look into fixing
> > this the right way, if someone doesn't beat us to it first.  :-)
> 
> You probably should resend the patch to netdev and Michael Chan
> <[email-masked]>.  He might have ideas on how this could be
> avoided.

This only shows up with the real-time kernel where timer softirq's run
in their own processes, and a high priority process preempts the timer
softirq.  I don't really consider this a networking bug, or even
driver bug, although it does seem unfortunate that Broadcom hardware
locks up and goes unresponsive if the OS doesn't tickle it every tenth
of a second or so.  (Definitely a bad idea if the tg3 gets used on any
laptops, from a power usage perspective.)  But that seems like a
(lame) hardware bug, not a driver bug....

						- Ted